Main Page | Modules | Class Hierarchy | Alphabetical List | Class List | File List | Class Members | Related Pages

# SoVRMLCollision Class Reference
[VRML97 classes]

`#include <Inventor/VRMLnodes/SoVRMLCollision.h>`

Inheritance diagram for SoVRMLCollision:

List of all members.

## Detailed Description

The SoVRMLCollision class is used for collision detection with the avatar.

The detailed class documentation is taken verbatim from the VRML97 standard (ISO/IEC 14772-1:1997). It is copyright The Web3D Consortium, and is used by permission of the Consortium:

      Collision {
        eventIn      MFNode   addChildren
        eventIn      MFNode   removeChildren
        exposedField MFNode   children        []
        exposedField SFBool   collide         TRUE
        field        SFVec3f  bboxCenter      0 0 0      # (-,)
        field        SFVec3f  bboxSize        -1 -1 -1   # (0,) or -1,-1,-1
        field        SFNode   proxy           NULL
        eventOut     SFTime   collideTime
      }

The Collision node is a grouping node that specifies the collision detection properties for its children (and their descendants), specifies surrogate objects that replace its children during collision detection, and sends events signalling that a collision has occurred between the avatar and the Collision node's geometry or surrogate. By default, all geometric nodes in the scene are collidable with the viewer except IndexedLineSet, PointSet, and Text. Browsers shall detect geometric collisions between the avatar (see SoVRMLNavigationInfo) and the scene's geometry and prevent the avatar from 'entering' the geometry. See 4.13.4, Collision detection and terrain following (<http://www.web3d.org/technicalinfo/specifications/vrml97/part1/concepts.html#4.13.4>), for general information on collision detection.

If there are no Collision nodes specified in a VRML file, browsers shall detect collisions between the avatar and all objects during navigation.

Subclause 4.6.5, Grouping and children nodes (<http://www.web3d.org/technicalinfo/specifications/vrml97/part1/concepts.html#4.6.5>), contains a description of the children, addChildren, and removeChildren fields and eventIns.

The Collision node's collide field enables and disables collision detection. If collide is set to FALSE, the children and all descendants of the Collision node shall not be checked for collision, even though they are drawn. This includes any descendent Collision nodes that have collide set to TRUE (i.e., setting collide to FALSE turns collision off for every node below it).

Collision nodes with the collide field set to TRUE detect the nearest collision with their descendent geometry (or proxies). When the nearest collision is detected, the collided Collision node sends the time of the collision through its collideTime eventOut. If a Collision node contains a child, descendant, or proxy (see below) that is a Collision node, and both Collision nodes detect that a collision has occurred, both send a collideTime event at the same time. A collideTime event shall be generated if the avatar is colliding with collidable geometry when the Collision node is read from a VRML file or inserted into the transformation hierarchy.

The bboxCenter and bboxSize fields specify a bounding box that encloses the Collision node's children. This is a hint that may be used for optimization purposes. The results are undefined if the specified bounding box is smaller than the actual bounding box of the children at any time. A default bboxSize value, (-1, -1, -1), implies that the bounding box is not specified and if needed shall be calculated by the browser. More details on the bboxCenter and bboxSize fields can be found in 4.6.4, Bounding boxes. (<http://www.web3d.org/technicalinfo/specifications/vrml97/part1/concepts.html#4.6.4>),

The collision proxy, defined in the proxy field, is any legal children node as described in 4.6.5, Grouping and children nodes, (<http://www.web3d.org/technicalinfo/specifications/vrml97/part1/concepts.html#4.6.5>), that is used as a substitute for the Collision node's children during collision detection. The proxy is used strictly for collision detection; it is not drawn. If the value of the collide field is TRUE and the proxy field is non-NULL, the proxy field defines the scene on which collision detection is performed. If the proxy value is NULL, collision detection is performed against the children of the Collision node. If proxy is specified, any descendent children of the Collision node are ignored during collision detection. If children is empty, collide is TRUE, and proxy is specified, collision detection is performed against the proxy but nothing is displayed. In this manner, invisible collision objects may be supported.

The collideTime eventOut generates an event specifying the time when the avatar (see SoVRMLNavigationInfo) makes contact with the collidable children or proxy of the Collision node. An ideal implementation computes the exact time of collision. Implementations may approximate the ideal by sampling the positions of collidable objects and the user. The SoVRMLNavigationInfo node contains additional information for parameters that control the avatar size.

## Public Member Functions
| SoVRMLCollision (void)
| SoVRMLCollision (int numchildren)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | notify (SoNotList *list)
## Static Public Member Functions
void | initClass (void)
## Public Attributes
SoSFBool | collide
SoSFNode | proxy
SoSFTime | collideTime
## Protected Member Functions
virtual | ~SoVRMLCollision ()

## Constructor & Destructor Documentation

SoVRMLCollision::SoVRMLCollision | ( | void |  | ) |

| Constructor.

SoVRMLCollision::SoVRMLCollision | ( | int | numchildren | ) |

| Constructor. numchildren is the expected number of children.

SoVRMLCollision::~SoVRMLCollision | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoVRMLCollision::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoVRMLGroup.

void SoVRMLCollision::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoVRMLGroup.

void SoVRMLCollision::notify | ( | SoNotList * | list | ) | `[virtual]`

| Notifies all auditors for this instance when changes are made. Reimplemented from SoVRMLGroup.

## Member Data Documentation

SoSFBool SoVRMLCollision::collide

| Enable/disable collision.

SoSFNode SoVRMLCollision::proxy

| Proxy node(s) used for collision testing.

SoSFTime SoVRMLCollision::collideTime

| An eventOut sent for each collision that occurs.

The documentation for this class was generated from the following files:

- SoVRMLCollision.h
- Collision.cpp